## org.apache.mahout.math.matrix.linalg
Class QRDecomposition

    java.lang.Object
      org.apache.mahout.math.matrix.linalg.QRDecomposition

All Implemented Interfaces:
  java.io.Serializable

Deprecated. until unit tests are in place. Until this time, this class/interface is unsupported.

    @Deprecated
    public class QRDecomposition

extends java.lang.Object
implements java.io.Serializable

See Also:
  Serialized Form

Constructor Summary
`QRDecomposition(DoubleMatrix2D A)` Deprecated. Constructs and returns a new QR decomposition object; computed by Householder reflections; The decomposed matrices can be retrieved via instance methods of the returned decomposition object.

Method Summary
`DoubleMatrix2D` `getH()` Deprecated. Returns the Householder vectors `H`.
`DoubleMatrix2D` `getQ()` Deprecated. Generates and returns the (economy-sized) orthogonal factor `Q`.
`DoubleMatrix2D` `getR()` Deprecated. Returns the upper triangular factor, `R`.
`boolean` `hasFullRank()` Deprecated. Returns whether the matrix `A` has full rank.
`DoubleMatrix2D` `solve(DoubleMatrix2D B)` Deprecated. Least squares solution of `A*X = B`; `returns X`.
`java.lang.String` `toString()` Deprecated. Returns a String with (propertyName, propertyValue) pairs.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### QRDecomposition

    public QRDecomposition(DoubleMatrix2D A)

  Deprecated.
  Constructs and returns a new QR decomposition object; computed by Householder reflections; The decomposed matrices can be retrieved via instance methods of the returned decomposition object.

  Parameters:
    `A` - A rectangular matrix.
  Throws:
    `java.lang.IllegalArgumentException` - if `A.rows() < A.columns()`.

Method Detail

### getH

    public DoubleMatrix2D getH()

  Deprecated.
  Returns the Householder vectors `H`.

  Returns:
    A lower trapezoidal matrix whose columns define the householder reflections.

### getQ

    public DoubleMatrix2D getQ()

  Deprecated.
  Generates and returns the (economy-sized) orthogonal factor `Q`.

  Returns:
    `Q`

### getR

    public DoubleMatrix2D getR()

  Deprecated.
  Returns the upper triangular factor, `R`.

  Returns:
    `R`

### hasFullRank

    public boolean hasFullRank()

  Deprecated.
  Returns whether the matrix `A` has full rank.

  Returns:
    true if `R`, and hence `A`, has full rank.

### solve

    public DoubleMatrix2D solve(DoubleMatrix2D B)

  Deprecated.
  Least squares solution of `A*X = B`; `returns X`.

  Parameters:
    `B` - A matrix with as many rows as `A` and any number of columns.
  Returns:
    `X` that minimizes the two norm of `Q*R*X - B`.
  Throws:
    `java.lang.IllegalArgumentException` - if `B.rows() != A.rows()`.
    `java.lang.IllegalArgumentException` - if `!this.hasFullRank()` (`A` is rank deficient).

### toString

    public java.lang.String toString()

  Deprecated.
  Returns a String with (propertyName, propertyValue) pairs. Useful for debugging or to quickly get the rough picture. For example,

       rank          : 3
       trace         : 0

  Overrides:
    `toString` in class `java.lang.Object`

Copyright © 2008-2010 The Apache Software Foundation. All Rights Reserved.